﻿'From Squeak3.8.1a of ''28 Aug 2006'' [latest update: #6666] on 22 March 2007 at 11:14:13 pm'!
Object subclass: #CpBaseModel
	instanceVariableNames: 'version modified userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-Model'!
WATask subclass: #CpBaseTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
WAComponent subclass: #CpBaseView
	instanceVariableNames: 'error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
CpBaseModel subclass: #CpCar
	instanceVariableNames: 'type licensePlateNumber logBook reservations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-Model'!
Smalltalk renameClassNamed: #CpCarReservationView as: #CpCarDetailView!
CpBaseView subclass: #CpCarDetailView
	instanceVariableNames: 'reservation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
CpBaseModel subclass: #CpCarPool
	instanceVariableNames: 'cars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-Model'!
Smalltalk renameClassNamed: #CpCarTypesView as: #CpCarSelectionView!
CpBaseView subclass: #CpCarSelectionView
	instanceVariableNames: 'reservation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
Smalltalk renameClassNamed: #CpCarManagement as: #CpCarService!
Object subclass: #CpCarService
	instanceVariableNames: ''
	classVariableNames: 'Cars'
	poolDictionaries: ''
	category: 'CarPool-Services'!
CpBaseModel subclass: #CpCarType
	instanceVariableNames: 'guid manufacturer model year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-Model'!
Smalltalk renameClassNamed: #CpCarTypeManagement as: #CpCarTypeService!
Object subclass: #CpCarTypeService
	instanceVariableNames: ''
	classVariableNames: 'CarTypes'
	poolDictionaries: ''
	category: 'CarPool-Services'!
CpBaseModel subclass: #CpDriver
	instanceVariableNames: 'personnelNumber firstName lastName department reservations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-Model'!
Smalltalk renameClassNamed: #CpDriverReservationsView as: #CpDriverDetailView!
CpBaseView subclass: #CpDriverDetailView
	instanceVariableNames: 'reservation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
CpBaseView subclass: #CpDriverSelectionView
	instanceVariableNames: 'reservation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
Object subclass: #CpDriverService
	instanceVariableNames: ''
	classVariableNames: 'Drivers'
	poolDictionaries: ''
	category: 'CarPool-Services'!
CpBaseModel subclass: #CpLogBook
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-Model'!
CpBaseModel subclass: #CpLogBookEntry
	instanceVariableNames: 'timestamp from till destination kilometers driver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-Model'!
Smalltalk renameClassNamed: #CpMainTask as: #CpMainMenuTask!
CpBaseTask subclass: #CpMainMenuTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
CpBaseView subclass: #CpMainMenuView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
Smalltalk renameClassNamed: #CpMainMenu as: #CpMainView!
WAComponent subclass: #CpMainView
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
CpBaseModel subclass: #CpReservation
	instanceVariableNames: 'car driver from till destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-Model'!
CpBaseView subclass: #CpReservationConfirmationView
	instanceVariableNames: 'reservation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
CpBaseView subclass: #CpReservationForm
	instanceVariableNames: 'reservation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!
CpBaseTask subclass: #CpReservationTask
	instanceVariableNames: 'views car driver reservation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarPool-UI'!

!CpBaseModel methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:15'!
modified
	^modified! !

!CpBaseModel methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:15'!
modified: aDate
	modified := aDate! !

!CpBaseModel methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:16'!
userName
	^userName! !

!CpBaseModel methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:16'!
userName: aString
	userName := aString! !

!CpBaseModel methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:14'!
version
	^version! !

!CpBaseModel methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:14'!
version: aNumber
	version := aNumber! !


!CpBaseView methodsFor: 'accessing' stamp: 'mue 10/1/2006 15:12'!
clearError
	error := nil! !

!CpBaseView methodsFor: 'accessing' stamp: 'mue 10/1/2006 15:11'!
error: aString
	error := aString! !

!CpBaseView methodsFor: 'rendering' stamp: 'mue 10/1/2006 15:13'!
renderContentOn: html
	error ifNotNil: [
		html divNamed: 'error' with: error]! !

!CpBaseView methodsFor: 'rendering' stamp: 'mue 10/3/2006 16:53'!
renderDateAndTimeInput: aDAT on: html callback: aBlock
	| values |
	aBlock fixTemps.
	values := Array new: 5.
	html
		selectFromList: (1 to: 31)
		selected: aDAT dayOfMonth 
		callback: [:day | values at: 1 put: day]
		labels: [:ea | ea asTwoCharacterString].
	html space; text: '.'; space.
	html
		selectFromList: (1 to: 12)
		selected: aDAT monthIndex 
		callback: [:month | values at: 2 put: month]
		labels: [:ea | ea asTwoCharacterString].
	html space; text: '.'; space.
	html
		selectFromList: (aDAT year to: (aDAT year + 2))
		selected: aDAT year
		callback: [:year | values at: 3 put: year].
	html space; space; space.
	html
		selectFromList: (0 to: 23)
		selected: aDAT hours
		callback: [:hour | values at: 4 put: hour]
		labels: [:ea | ea asTwoCharacterString].
	html space; text: ':'; space.
	html
		selectFromList: (0 to: 59)
		selected: aDAT minutes
		callback: [:minute | values at: 5 put: minute]
		labels: [:ea | ea asTwoCharacterString].
	"Callback."
	html hiddenInputWithCallback: [
		| ye mo da ho mi dat |
		ye := values third asNumber.
		mo := values second asNumber.
		da := values first asNumber.
		ho := values fourth asNumber.
		mi := values fifth asNumber.
		[
			[
				dat := DateAndTime year: ye month: mo day: da hour: ho minute: mi.
				aBlock value: dat.
				true
			]
				on: Error
				do: 
				[:err | 
					(da = 1)
						ifTrue: [
							da := 31.
							mo := mo - 1]
						ifFalse: [
							da := da - 1].
					false
				]
		] whileFalse]! !

!CpBaseView methodsFor: 'rendering' stamp: 'mue 10/1/2006 15:01'!
renderTitle: aString on: html
	html heading: aString isoToUtf8 ! !


!CpCar methodsFor: 'accessing' stamp: 'mue 9/27/2006 19:14'!
licensePlateNumber
	^licensePlateNumber! !

!CpCar methodsFor: 'accessing' stamp: 'mue 9/27/2006 19:13'!
licensePlateNumber: aString
	licensePlateNumber := aString! !

!CpCar methodsFor: 'accessing' stamp: 'mue 9/27/2006 19:13'!
type
	^type! !

!CpCar methodsFor: 'accessing' stamp: 'mue 9/27/2006 19:13'!
type: aType
	type := aType! !

!CpCar methodsFor: 'logbook' stamp: 'mue 9/27/2006 19:21'!
addLogBookEntry: anEntry
	logBook ifNil: [logBook := CpLogBook new].
	logBook addEntry: anEntry! !

!CpCar methodsFor: 'logbook' stamp: 'mue 9/27/2006 19:49'!
kilometers
	"Calculate the kilometers out of the log entries."
	| kilometers |
	kilometers := 0.
	self logBookEntriesDo: [:eachEntry |
		kilometers := kilometers + eachEntry kilometers].
	^kilometers ! !

!CpCar methodsFor: 'logbook' stamp: 'mue 9/27/2006 19:44'!
logBookEntriesDo: aBlock
	^logBook ifNotNil: [logBook entriesDo: aBlock]! !

!CpCar methodsFor: 'reservations' stamp: 'mue 9/28/2006 10:34'!
addReservation: aReservation
	reservations ifNil: [reservations := Set new].
	reservations add: aReservation ! !

!CpCar methodsFor: 'reservations' stamp: 'mue 9/28/2006 10:36'!
cancelReservation: aReservation
	reservations ifNotNil: [reservations remove: aReservation]! !

!CpCar methodsFor: 'reservations' stamp: 'mue 9/28/2006 10:36'!
reservationsDo: aBlock
	^reservations ifNotNil: [reservations do: aBlock]! !


!CpCarDetailView methodsFor: 'accessing' stamp: 'mue 10/10/2006 22:10'!
reservation: aReservation
	reservation := aReservation ! !

!CpCarDetailView methodsFor: 'rendering' stamp: 'mue 10/23/2006 20:53'!
renderContentOn: html
	"Show the car with a table with all reservations."
	self renderTitle: 'Fahrzeug-Auswahl bestätigen' on: html.
	"Display the car data."
	html table: [
		html 
			tableRowWithLabel: 'Hersteller' column: [html text: reservation car type manufacturer];
			tableRowWithLabel: 'Modell' column: [html text: reservation car type model];
			tableRowWithLabel: 'Baujahr' column: [html text: reservation car type year asString];
			tableRowWithLabel: 'Kennzeichen' column: [html text: reservation car licensePlateNumber]].
	"Display the reservations."
	html heading: 'Reservierungen' level: 2.
	html table: [
		"Render the heading."
		html tableRow: [
			html 
				tableHeading: [html text: 'Fahrer'];
				tableHeading: [html text: 'Reiseziel'];
				tableHeading: [html text: 'Von'];
				tableHeading: [html text: 'Bis']].
		"Render all reservations."
		reservation car reservationsDo: [:eachReservation |
			html tableRow: [
				html
					tableData: [html text: (eachReservation driver firstName , ' ' , eachReservation driver lastName) isoToUtf8 ];
					tableData: [html text: eachReservation destination isoToUtf8];
					tableData: [html text: eachReservation from asString];
					tableData: [html text: eachReservation till asString]]]].
	"Show actions."
	html hr.
	html form: [
		html submitButtonWithAction: [self answer: #cancel] text: 'Abbruch'.
		html space.
		html submitButtonWithAction: [self answer: #back] text: 'Zurück' isoToUtf8.
		html space.
		html submitButtonWithAction: [self answer: #next] text: 'Weiter']! !


!CpCarSelectionView methodsFor: 'accessing' stamp: 'mue 10/23/2006 21:10'!
reservation: aReservation
	reservation := aReservation! !

!CpCarSelectionView methodsFor: 'rendering' stamp: 'mue 10/23/2006 21:16'!
renderContentOn: html
	| cars |
	cars := CpCarService new selectAll.
	"Show a table with all cars for selection."
	self renderTitle: 'Fahrzeugauswahl' on: html.
	html form: [
		html table: [
			"Render the heading."
			html tableRow: [
				html 
					tableHeading: [html text: 'Hersteller'];
					tableHeading: [html text: 'Modell'];
					tableHeading: [html text: 'Baujahr'];
					tableHeading: [html text: 'Kennzeichen'];
					tableHeading: [html text: 'Aktion']].
			"Render all cars."
			cars do: [:eachCar |
				html tableRow: [
					html
						tableData: [html text: eachCar type manufacturer];
						tableData: [html text: eachCar type model];
						tableData: [html text: eachCar type year asString];
						tableData: [html text: eachCar licensePlateNumber];
						tableData: [html submitButtonWithAction: [
										reservation car: eachCar.
										self answer: #next] text: 'Auswählen' isoToUtf8]]]].
	"Show actions."
	html hr.
	html submitButtonWithAction: [self answer: #cancel] text: 'Abbruch']! !


!CpCarService methodsFor: 'adding' stamp: 'mue 9/29/2006 12:13'!
add: aCar
	^Cars at: aCar licensePlateNumber put: aCar! !

!CpCarService methodsFor: 'adding' stamp: 'mue 9/29/2006 12:14'!
at: aLicensePlateNumber
	^Cars at: aLicensePlateNumber ! !

!CpCarService methodsFor: 'initialize-release' stamp: 'mue 9/29/2006 14:53'!
initialize
	Cars ifNil: [
		| carTypes |
		carTypes := CpCarTypeService new selectAll.
		Cars := Dictionary new.
		self add: ((CpCar new) type: (carTypes at: 1); licensePlateNumber: 'OL-IX901').
		self add: ((CpCar new) type: (carTypes at: 1); licensePlateNumber: 'OL-IX902').
		self add: ((CpCar new) type: (carTypes at: 2); licensePlateNumber: 'OL-IX903').
		self add: ((CpCar new) type: (carTypes at: 3); licensePlateNumber: 'OL-IX904')]! !

!CpCarService methodsFor: 'retrieving' stamp: 'mue 9/30/2006 22:49'!
selectAll
	^Cars values asArray! !

!CpCarService methodsFor: 'retrieving' stamp: 'mue 9/29/2006 12:01'!
select: aBlock
	^self selectAll select: aBlock
! !


!CpCarType methodsFor: 'accessing' stamp: 'mue 9/28/2006 11:01'!
guid
	^guid! !

!CpCarType methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:29'!
manufacturer
	^manufacturer! !

!CpCarType methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:29'!
manufacturer: aString
	manufacturer := aString! !

!CpCarType methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:35'!
model
	^model! !

!CpCarType methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:30'!
model: aString
	model := aString! !

!CpCarType methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:28'!
year
	^year! !

!CpCarType methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:28'!
year: aNumber
	year := aNumber! !

!CpCarType methodsFor: 'initialize-release' stamp: 'mue 9/28/2006 11:02'!
initialize
	guid := UUID new! !


!CpCarTypeService methodsFor: 'adding' stamp: 'mue 9/29/2006 12:11'!
add: aCarType
	CarTypes add: aCarType! !

!CpCarTypeService methodsFor: 'initialize-release' stamp: 'mue 9/29/2006 12:12'!
initialize
	CarTypes ifNil: [
		CarTypes := Set new.
		self add: (CpCarType new manufacturer: 'Ford'; model: 'Focus'; year: 2006).
		self add: (CpCarType new manufacturer: 'VW'; model: 'Golf'; year: 2004).
		self add: (CpCarType new manufacturer: 'VW'; model: 'Passat'; year: 2005)]! !

!CpCarTypeService methodsFor: 'retrieving' stamp: 'mue 9/29/2006 12:11'!
selectAll
	^CarTypes asArray! !

!CpCarTypeService methodsFor: 'retrieving' stamp: 'mue 9/29/2006 12:02'!
select: aBlock
	^self selectAll select: aBlock
! !


!CpDriver methodsFor: 'accessing' stamp: 'mue 9/30/2006 22:36'!
department
	^department! !

!CpDriver methodsFor: 'accessing' stamp: 'mue 9/30/2006 22:36'!
department: aString
	department := aString! !

!CpDriver methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:23'!
firstName
	^firstName! !

!CpDriver methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:23'!
firstName: aString
	firstName := aString! !

!CpDriver methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:23'!
lastName
	^lastName! !

!CpDriver methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:23'!
lastName: aString
	lastName := aString! !

!CpDriver methodsFor: 'accessing' stamp: 'mue 9/30/2006 22:35'!
personnelNumber
	^personnelNumber ! !

!CpDriver methodsFor: 'accessing' stamp: 'mue 9/30/2006 22:35'!
personnelNumber: aNumber
	personnelNumber := aNumber! !

!CpDriver methodsFor: 'reservations' stamp: 'mue 9/30/2006 23:42'!
addReservation: aReservation
	reservations ifNil: [reservations := Set new].
	reservations add: aReservation ! !

!CpDriver methodsFor: 'reservations' stamp: 'mue 9/30/2006 23:42'!
cancelReservation: aReservation
	reservations ifNotNil: [reservations remove: aReservation]! !

!CpDriver methodsFor: 'reservations' stamp: 'mue 9/30/2006 23:42'!
reservationsDo: aBlock
	^reservations ifNotNil: [reservations do: aBlock]! !


!CpDriverDetailView methodsFor: 'accessing' stamp: 'mue 10/10/2006 22:37'!
reservation: aReservation
	reservation := aReservation ! !

!CpDriverDetailView methodsFor: 'rendering' stamp: 'mue 10/23/2006 20:54'!
renderContentOn: html
	"Show the driver with a table with all reservations."
	self  renderTitle: 'Fahrer-Auswahl bestätigen' on: html.
	"Display the driver data."
	html table: [
		html 
			tableRowWithLabel: 'Personalnummer' column: [html text: reservation driver personnelNumber asString];
			tableRowWithLabel: 'Vorname' column: [html text: reservation driver firstName isoToUtf8];
			tableRowWithLabel: 'Nachname' column: [html text: reservation driver lastName isoToUtf8];
			tableRowWithLabel: 'Abteilung' column: [html text: reservation driver department isoToUtf8]].
	"Display the reservations."
	html heading: 'Reservierungen' level: 2.
	html table: [
		"Render the heading."
		html tableRow: [
			html 
				tableHeading: [html text: 'Kennzeichen'];
				tableHeading: [html text: 'Reiseziel'];
				tableHeading: [html text: 'Von'];
				tableHeading: [html text: 'Bis']].
		"Render all reservations."
		reservation driver reservationsDo: [:eachReservation |
			html tableRow: [
				html
					tableData: [html text: eachReservation car licensePlateNumber];
					tableData: [html text: eachReservation destination isoToUtf8];
					tableData: [html text: eachReservation from asString];
					tableData: [html text: eachReservation till asString]]]].
	"Show actions."
	html hr.
	html form: [
		html submitButtonWithAction: [self answer: #cancel] text: 'Abbruch'.
		html space.
		html submitButtonWithAction: [self answer: #back] text: 'Zurück' isoToUtf8.
		html space.
		html submitButtonWithAction: [self answer: #next] text: 'Weiter']
! !


!CpDriverSelectionView methodsFor: 'accessing' stamp: 'mue 10/10/2006 22:48'!
reservation: aReservation
	reservation := aReservation ! !

!CpDriverSelectionView methodsFor: 'rendering' stamp: 'mue 10/23/2006 21:17'!
renderContentOn: html
	| drivers |
	drivers := CpDriverService new selectAll.
	"Show a table with all drivers for selection."
	self renderTitle: 'Fahrerauswahl' on: html.
	html form: [
		html table: [
			"Render the heading."
			html tableRow: [
				html 
					tableHeading: [html text: 'P/N'];
					tableHeading: [html text: 'Vorname'];
					tableHeading: [html text: 'Nachname'];
					tableHeading: [html text: 'Abteilung'];
					tableHeading: [html text: 'Aktion']].
			"Render all drivers."
			drivers do: [:eachDriver |
				html tableRow: [
					html
						tableData: [html text: eachDriver personnelNumber asString];
						tableData: [html text: eachDriver firstName isoToUtf8];
						tableData: [html text: eachDriver lastName isoToUtf8];
						tableData: [html text: eachDriver department isoToUtf8];
						tableData: [html submitButtonWithAction: [
										reservation driver: eachDriver.
										self answer: #next] text: 'Auswählen' isoToUtf8]]]].
	"Show actions."
	html hr.
	html submitButtonWithAction: [self answer: #cancel] text: 'Abbruch'.
	html space.
	html submitButtonWithAction: [self answer: #back] text: 'Zurück' isoToUtf8]! !


!CpDriverService methodsFor: 'adding' stamp: 'mue 9/30/2006 22:40'!
add: aDriver
	Drivers at: aDriver personnelNumber put: aDriver! !

!CpDriverService methodsFor: 'initialize-release' stamp: 'mue 9/30/2006 22:47'!
initialize
	Drivers ifNil: [
		Drivers := Dictionary new.
		self add: (CpDriver new personnelNumber: 1; firstName: 'Kurt'; lastName: 'Boss'; department: 'Geschäftsführer').
		self add: (CpDriver new personnelNumber: 2; firstName: 'Frank'; lastName: 'Müller'; department: 'Entwicklung').
		self add: (CpDriver new personnelNumber: 3; firstName: 'Hans'; lastName: 'Meier'; department: 'Entwicklung').
		self add: (CpDriver new personnelNumber: 4; firstName: 'Egon'; lastName: 'Schmidt'; department: 'Buchhaltung').
		self add: (CpDriver new personnelNumber: 5; firstName: 'Uschi'; lastName: 'Schulz'; department: 'Buchhaltung').
		self add: (CpDriver new personnelNumber: 6; firstName: 'Lisa'; lastName: 'Plenske'; department: 'Vertrieb').
		self add: (CpDriver new personnelNumber: 7; firstName: 'Rokko'; lastName: 'Kowalski'; department: 'Vertrieb')]! !

!CpDriverService methodsFor: 'retrieving' stamp: 'mue 9/30/2006 22:49'!
selectAll
	^Drivers values asArray! !

!CpDriverService methodsFor: 'retrieving' stamp: 'mue 9/30/2006 22:50'!
select: aBlock
	^self selectAll select: aBlock
! !


!CpLogBook methodsFor: 'enumerating' stamp: 'mue 9/27/2006 18:51'!
entriesDo: aBlock
	entries ifNotNil: [entries do: aBlock]! !

!CpLogBook methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:49'!
addEntry: anEntry
	entries ifNil: [entries := Set new].
	entries add: anEntry! !


!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:17'!
destination
	^destination! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:17'!
destination: aString
	destination := aString! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:47'!
driver
	^driver! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:46'!
driver: aDriver
	driver := aDriver! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/28/2006 10:31'!
from
	^from! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:17'!
from: aTimeStamp
	from := aTimeStamp! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:46'!
kilometers
	^kilometers! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:46'!
kilometers: aNumber
	kilometers := aNumber! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:16'!
till
	^till! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:16'!
till: aTimeStamp
	till := aTimeStamp ! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:47'!
timestamp
	^timestamp! !

!CpLogBookEntry methodsFor: 'accessing' stamp: 'mue 9/27/2006 18:47'!
timestamp: aTimestamp
	timestamp := aTimestamp ! !


!CpMainMenuTask methodsFor: 'rendering' stamp: 'mue 9/29/2006 13:12'!
go
	self isolate: [[self call: CpMainMenuView new] whileTrue]! !


!CpMainMenuView methodsFor: 'call/answer' stamp: 'mue 9/29/2006 13:06'!
doAddLogEntry! !

!CpMainMenuView methodsFor: 'call/answer' stamp: 'mue 9/29/2006 13:07'!
doCarReport
	! !

!CpMainMenuView methodsFor: 'call/answer' stamp: 'mue 9/29/2006 13:15'!
doReservation
	self call: CpReservationTask new
! !

!CpMainMenuView methodsFor: 'rendering' stamp: 'mue 10/1/2006 15:07'!
renderContentOn: html
	self renderTitle: 'Menü' on: html.
	html unorderedList: [
		html 
			listItem: [html anchorWithAction: [self doReservation] text: 'Fahrzeug reservieren...'];
			listItem: [html anchorWithAction: [self doAddLogEntry] text: 'Logbucheintrag vornehmen...'];
			listItem: [html anchorWithAction: [self doCarReport] text: 'Fahrzeug-Logbuch auswerten...']]! !


!CpMainView methodsFor: 'initialize-release' stamp: 'mue 10/1/2006 15:39'!
initialize
	task := CpMainMenuTask new! !

!CpMainView methodsFor: 'rendering' stamp: 'mue 10/1/2006 15:39'!
renderContentOn: html
	html divNamed: 'banner' with: 'Fuhrparkverwaltung'.
	html divNamed: 'body' with: task.
	html divNamed: 'footer' with: TimeStamp now asString! !

!CpMainView methodsFor: 'rendering' stamp: 'mue 10/1/2006 14:29'!
style
	^ '
	body {margin: 0px; font-size: 10pt; font-family: sans-serif}
	h1 {font-size: 14pt}
	h2 {font-size: 12pt}
	th {color: black; background-color: lightgrey; font-weight: bold; padding: 5px}
	td {color: grey; background-color: white; padding: 5px}
	td.label {color: black; background-color: lightgrey; font-weight: bold; padding: 5px}
	#banner {color: white; background-color: blue; font-size: 16pt; width: 99.9%; padding: 5px}
	#error {color: yellow; background-color: red; font-weight: bold; width: 99.9%; padding: 5px}
	#body {padding: 5px}
	#footer {color: blue; background-color: lightblue; font-size: 8pt; width: 99.9%; padding: 5px}
	.buttons {background-color: lightgrey; width: 99.9%; padding: 5px}'! !

!CpMainView methodsFor: 'tree' stamp: 'mue 9/29/2006 12:34'!
children
	^Array with: task! !


!CpMainView class methodsFor: 'accessing' stamp: 'mue 9/29/2006 14:09'!
canBeRoot
	^true! !


!CpReservation methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:12'!
car
	^car! !

!CpReservation methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:12'!
car: aCar
	car := aCar! !

!CpReservation methodsFor: 'accessing' stamp: 'mue 10/23/2006 21:24'!
destination
	destination ifNil: [destination := ''].
	^destination! !

!CpReservation methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:15'!
destination: aString
	destination := aString ! !

!CpReservation methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:13'!
driver
	^driver! !

!CpReservation methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:12'!
driver: aDriver
	driver := aDriver ! !

!CpReservation methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:13'!
from
	^from! !

!CpReservation methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:13'!
from: aTimeStamp
	from := aTimeStamp! !

!CpReservation methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:14'!
till
	^till! !

!CpReservation methodsFor: 'accessing' stamp: 'mue 9/29/2006 15:15'!
till: aTimeStamp
	till := aTimeStamp! !

!CpReservation methodsFor: 'initialize-release' stamp: 'mue 10/10/2006 23:11'!
initialize
	from := DateAndTime now.
	till := DateAndTime now! !

!CpReservation methodsFor: 'reservation' stamp: 'mue 10/9/2006 22:28'!
reserve
	car addReservation: self.
	driver addReservation: self! !


!CpReservationConfirmationView methodsFor: 'accessing' stamp: 'mue 10/3/2006 17:22'!
reservation: aReservation
	reservation := aReservation! !

!CpReservationConfirmationView methodsFor: 'rendering' stamp: 'mue 10/23/2006 21:47'!
renderContentOn: html
	"Show the reservation for confirmation."
	self renderTitle: 'Reservierung bestätigen' on: html.
	"Display the reservation data."
	html table: [
		html 
			tableRowWithLabel: 'Hersteller' column: [html text: reservation car type manufacturer];
			tableRowWithLabel: 'Modell' column: [html text: reservation car type model];
			tableRowWithLabel: 'Baujahr' column: [html text: reservation car type year asString];
			tableRowWithLabel: 'Kennzeichen' column: [html text: reservation car licensePlateNumber];
			tableRowWithLabel: 'Personalnummer' column: [html text: reservation driver personnelNumber asString];
			tableRowWithLabel: 'Vorname' column: [html text: reservation driver firstName isoToUtf8];
			tableRowWithLabel: 'Nachname' column: [html text: reservation driver lastName isoToUtf8];
			tableRowWithLabel: 'Abteilung' column: [html text: reservation driver department isoToUtf8];
			tableRowWithLabel: 'Von' column: [html text: reservation from asString];
			tableRowWithLabel: 'Bis' column: [html text: reservation till asString];
			tableRowWithLabel: 'Reiseziel' column: [html text: reservation destination isoToUtf8]].
	"Show actions."
	html hr.
	html form: [
		html submitButtonWithAction: [self answer: #cancel] text: 'Abbruch'.
		html space.
		html submitButtonWithAction: [self answer: #back] text: 'Zurück' isoToUtf8.
		html space.
		html submitButtonWithAction: [self answer: #finish] text: 'Fertigstellen']
! !


!CpReservationForm methodsFor: 'accessing' stamp: 'mue 10/1/2006 00:27'!
reservation: aReservation
	reservation := aReservation ! !

!CpReservationForm methodsFor: 'convenience' stamp: 'mue 10/1/2006 00:32'!
carInfo
	| car |
	car := reservation car.
	^car type manufacturer , ' ' , car type model , ' ' , car licensePlateNumber! !

!CpReservationForm methodsFor: 'convenience' stamp: 'mue 10/1/2006 00:33'!
driverInfo
	| driver |
	driver := reservation driver.
	^driver firstName , ' ' , driver lastName! !

!CpReservationForm methodsFor: 'rendering' stamp: 'mue 10/1/2006 20:29'!
renderCarInfoOn: html
	| car carInfo |
	car := reservation car.
	carInfo := car type manufacturer , ' ' , car type model , ' (' , car licensePlateNumber , ')'.
	html text: carInfo isoToUtf8! !

!CpReservationForm methodsFor: 'rendering' stamp: 'mue 10/23/2006 21:46'!
renderContentOn: html
	super renderContentOn: html.
	self renderTitle: 'Reservierung' on: html.
	html form: [
		html table: [
			html tableRowWithLabel: 'Fahrzeug' column: [self renderCarInfoOn: html].
			html tableRowWithLabel: 'Fahrer' column: [self renderDriverInfoOn: html].
			html tableRowWithLabel: 'Von' column: [self renderFromOn: html].
			html tableRowWithLabel: 'Bis' column: [self renderTillOn: html].
			html tableRowWithLabel: 'Ziel' column: [self renderDestinationOn: html]].
		html hr.
		html submitButtonWithAction: [self answer: #cancel] text: 'Abbruch'.
		html space.
		html submitButtonWithAction: [self answer: #back] text: 'Zurück' isoToUtf8.
		html space.
		html submitButtonWithAction: [self answer: #next] text: 'Übernehmen' isoToUtf8]! !

!CpReservationForm methodsFor: 'rendering' stamp: 'mue 10/9/2006 22:42'!
renderDestinationOn: html
	html textInputWithValue: reservation destination callback: [:value | value ifNotNil: [reservation destination: value utf8ToIso]] maxLength: 100
! !

!CpReservationForm methodsFor: 'rendering' stamp: 'mue 10/1/2006 20:32'!
renderDriverInfoOn: html
	| driver driverInfo |
	driver := reservation driver.
	driverInfo := driver firstName , ' ' , driver lastName , ' (' , driver personnelNumber asString , ')'.
	html text: driverInfo isoToUtf8! !

!CpReservationForm methodsFor: 'rendering' stamp: 'mue 10/3/2006 17:45'!
renderFromOn: html
	self renderDateAndTimeInput: reservation from on: html callback: [:value | reservation from: value]! !

!CpReservationForm methodsFor: 'rendering' stamp: 'mue 10/3/2006 17:45'!
renderTillOn: html
	self renderDateAndTimeInput: reservation till on: html callback: [:value | reservation till: value]! !


!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 10/3/2006 16:20'!
confirmCar
	| carView |
	carView := CpCarDetailView new car: car; mode: #car.
	^self call: carView
! !

!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 10/3/2006 16:21'!
confirmDriver
	| driverView |
	driverView := CpDriverDetailView new driver: driver; mode: #driver.
	^self call: driverView
! !

!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 10/9/2006 22:36'!
confirmReservation
	| confirmationView |
	confirmationView := CpReservationConfirmationView new reservation: reservation.
	(self call: confirmationView)
		ifTrue: [
			reservation reserve.
			^true]
		ifFalse: [
			^false]
! !

!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 10/9/2006 23:12'!
makeReservation
	| reservationForm |
	reservation := CpReservation new car: car; driver: driver.
	reservationForm := CpReservationForm new reservation: reservation.
	^self call: reservationForm ! !

!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 10/1/2006 22:13'!
reservationIsValid
	^true! !

!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 10/9/2006 23:16'!
selectAndConfirmCar
	self selectCar.
	self confirmCar! !

!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 10/9/2006 23:17'!
selectAndConfirmDriver
	self selectDriver.
	self confirmDriver! !

!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 9/30/2006 12:14'!
selectCar
	| carService carSelectionView |
	carService := CpCarService new.
	carSelectionView := CpCarSelectionView new cars: carService selectAll.
	car := self call: carSelectionView
! !

!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 9/30/2006 23:16'!
selectDriver
	| driverService driverSelectionView |
	driverService := CpDriverService new.
	driverSelectionView := CpDriverSelectionView new drivers: driverService selectAll.
	driver := self call: driverSelectionView
! !

!CpReservationTask methodsFor: 'call/answer' stamp: 'mue 10/9/2006 23:04'!
showError
	^false! !

!CpReservationTask methodsFor: 'initialize-release' stamp: 'mue 10/23/2006 21:42'!
initialize
	reservation := CpReservation new.
	"Init views."
	views := Array new: 6.
	views at: 1 put: (CpCarSelectionView new reservation: reservation).
	views at: 2 put: (CpCarDetailView new reservation: reservation).
	views at: 3 put: (CpDriverSelectionView new reservation: reservation).
	views at: 4 put: (CpDriverDetailView new reservation: reservation).
	views at: 5 put: (CpReservationForm new reservation: reservation).
	views at: 6 put: (CpReservationConfirmationView new reservation: reservation)
	! !

!CpReservationTask methodsFor: 'rendering' stamp: 'mue 10/23/2006 22:16'!
go
	"Initiate a switch dictionary."
	| actions |
	actions := Dictionary new.
	actions at: #next put: [:value | value + 1].
	actions at: #back put: [:value | value - 1].
	actions at: #cancel put: [:value | ].
	actions at: #finish put: [:value | 1].
	"Transaction."
	self isolate: [
		| current answer |
		current := 1.
		answer := #start.
		[(answer = #finish) or: [answer = #cancel]] whileFalse: [
			answer := self call: (views at: current).
			(answer = #finish) ifTrue: [self break].
			current := (actions at: answer) value: current]]! !

CpReservationTask removeSelector: #goSave!
CpReservationTask removeSelector: #showReservations:!

!CpReservationTask reorganize!
('call/answer' confirmCar confirmDriver confirmReservation makeReservation reservationIsValid selectAndConfirmCar selectAndConfirmDriver selectCar selectDriver showError)
('initialize-release' initialize)
('rendering' go)
!


!CpReservationForm reorganize!
('accessing' reservation:)
('call/answer')
('convenience' carInfo driverInfo)
('rendering' renderCarInfoOn: renderContentOn: renderDestinationOn: renderDriverInfoOn: renderFromOn: renderTillOn:)
!

CpReservationConfirmationView removeSelector: #car:!
CpReservationConfirmationView removeSelector: #mode:!
CpReservation removeSelector: #to!
CpReservation removeSelector: #to:!

!CpReservation reorganize!
('accessing' car car: destination destination: driver driver: from from: till till:)
('initialize-release' initialize)
('reservation' reserve)
!


!CpMainView class reorganize!
('accessing' canBeRoot)
!

CpMainView removeSelector: #clearError!
CpMainView removeSelector: #doAddLogEntry!
CpMainView removeSelector: #doCarReport!
CpMainView removeSelector: #doReservation!
CpMainView removeSelector: #error:!

!CpMainView reorganize!
('accessing')
('initialize-release' initialize)
('rendering' renderContentOn: style)
('tree' children)
!


!CpMainMenuView reorganize!
('call/answer' doAddLogEntry doCarReport doReservation)
('rendering' renderContentOn:)
!

CpMainMenuTask removeSelector: #doMainMenu!
CpMainMenuTask removeSelector: #mainView!
CpMainMenuTask removeSelector: #mainView:!

!CpMainMenuTask reorganize!
('rendering' go)
!

CpLogBookEntry removeSelector: #to!
CpLogBookEntry removeSelector: #to:!

!CpLogBookEntry reorganize!
('accessing' destination destination: driver driver: from from: kilometers kilometers: till till: timestamp timestamp:)
!


!CpLogBook reorganize!
('enumerating' entriesDo:)
('accessing' addEntry:)
!


!CpDriverService reorganize!
('adding' add:)
('initialize-release' initialize)
('retrieving' selectAll select:)
!

CpDriverSelectionView removeSelector: #cars:!
CpDriverSelectionView removeSelector: #drivers:!
CpDriverDetailView removeSelector: #car:!
CpDriverDetailView removeSelector: #driver:!
CpDriverDetailView removeSelector: #mode:!

!CpDriver reorganize!
('accessing' department department: firstName firstName: lastName lastName: personnelNumber personnelNumber:)
('reservations' addReservation: cancelReservation: reservationsDo:)
!

CpCarTypeService class removeSelector: #new!

!CpCarTypeService class reorganize!
('as yet unclassified')
!


!CpCarTypeService reorganize!
('adding' add:)
('initialize-release' initialize)
('retrieving' selectAll select:)
!


!CpCarType reorganize!
('accessing' guid manufacturer manufacturer: model model: year year:)
('initialize-release' initialize)
!

CpCarService class removeSelector: #new!

!CpCarService class reorganize!
('as yet unclassified')
!

CpCarService removeSelector: #intialize!

!CpCarService reorganize!
('adding' add: at:)
('initialize-release' initialize)
('retrieving' selectAll select:)
!

CpCarSelectionView removeSelector: #car!
CpCarSelectionView removeSelector: #cars:!
CpCarSelectionView removeSelector: #carTypes:!
CpCarSelectionView removeSelector: #car:!

!CpCarSelectionView reorganize!
('accessing' reservation:)
('rendering' renderContentOn:)
!

CpCarDetailView removeSelector: #car:!
CpCarDetailView removeSelector: #mode:!

!CpCarDetailView reorganize!
('accessing' reservation:)
('rendering' renderContentOn:)
!


!CpCar reorganize!
('accessing' licensePlateNumber licensePlateNumber: type type:)
('initialize-release')
('logbook' addLogBookEntry: kilometers logBookEntriesDo:)
('testing')
('reservations' addReservation: cancelReservation: reservationsDo:)
!

CpBaseView removeSelector: #renderTimeStamp:on:callback:!

!CpBaseView reorganize!
('accessing' clearError error:)
('rendering' renderContentOn: renderDateAndTimeInput:on:callback: renderTitle:on:)
!

CpBaseTask removeSelector: #clearError!
CpBaseTask removeSelector: #error:!
CpBaseTask removeSelector: #mainView!
CpBaseTask removeSelector: #mainView:!

!CpBaseTask reorganize!
('as yet unclassified')
!


!CpBaseModel reorganize!
('accessing' modified modified: userName userName: version version:)
!

